package forestry.api.arboriculture;

import java.util.ArrayList;

import forestry.api.genetics.IEffectData;
import forestry.api.genetics.IIndividual;

import net.minecraft.src.World;
import net.minecraft.src.WorldGenerator;

public interface ITree extends IIndividual {

	void mate(ITree other);

	IEffectData[] doEffect(IEffectData[] storedData, World world, int biomeid, int x, int y, int z);

	IEffectData[] doFX(IEffectData[] storedData, World world, int biomeid, int x, int y, int z);

	ArrayList<Integer> getSuitableBiomeIds();

	ITreeGenome getGenome();
	ITreeGenome getMate();

	ITreeGenome[] getSaplings(World world, int x, int y, int z);

	/**
	 * 
	 * @param world
	 * @param x
	 * @param y
	 * @param z
	 * @return Boolean indicating whether a sapling can stay planted at the given position.
	 */
	boolean canStay(World world, int x, int y, int z);
	/**
	 * 
	 * @param world
	 * @param x
	 * @param y
	 * @param z
	 * @return Boolean indicating whether a sapling at the given position can grow into a tree.
	 */
	boolean canGrow(World world, int x, int y, int z);
	/**
	 * 
	 * @param world
	 * @param x
	 * @param y
	 * @param z
	 * @return Growth conditions at the given position.
	 */
	EnumGrowthConditions getGrowthCondition(World world, int x, int y, int z);

	WorldGenerator getTreeGenerator();
}
